import { createRequire } from 'module';
export const _revertSymbolSeries = Symbol.for('@@originalList:series');
export const _revertSymbolParallel = Symbol.for('@@originalList:parallel');
function wrapList(tasks, symbol) {
    const wrapTasks = [];
    for (const item of tasks) {
        if (Array.isArray(item)) {
            wrapTasks.push(...item);
        }
        else if (typeof item === 'string') {
            wrapTasks.push(item);
        }
        else if (symbol in item) {
            wrapTasks.push(...item[symbol]);
        }
        else {
            wrapTasks.push(item);
        }
    }
    return wrapTasks;
}
export function series(gulp, ...tasks) {
    const wrapTasks = wrapList(tasks, _revertSymbolSeries);
    return Object.assign(gulp.series(...wrapTasks), { [_revertSymbolSeries]: wrapTasks });
}
export function gulpSeries(...tasks) {
    const wrapTasks = wrapList(tasks, _revertSymbolSeries);
    return Object.assign(parentGulp().series(...wrapTasks), { [_revertSymbolSeries]: wrapTasks });
}
export function parallel(gulp, ...tasks) {
    const wrapTasks = wrapList(tasks, _revertSymbolParallel);
    return Object.assign(gulp.parallel(...wrapTasks), { [_revertSymbolParallel]: wrapTasks });
}
export function gulpParallel(...tasks) {
    const wrapTasks = wrapList(tasks, _revertSymbolParallel);
    return Object.assign(parentGulp().parallel(...wrapTasks), { [_revertSymbolParallel]: wrapTasks });
}
let gulpInstance;
function parentGulp() {
    if (!gulpInstance) {
        const require = createRequire(import.meta.url);
        const mainRequire = require.main?.require ?? require;
        gulpInstance = mainRequire('gulp');
    }
    return gulpInstance;
}
//# sourceMappingURL=index.js.map